Unit SF66R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ZP49R_p, UTSF16_p;

procedure SF66R(X :Real; var ALNGX :Real; var IER :Integer);

implementation

procedure SF66R(X :Real; var ALNGX :Real; var IER :Integer);
var
Y,SX,Z :Real;
C :Array [0..26] of Real;
const
SYS027 :Real = 0.91893853320467274178032973640561;
N :Integer = 27;
label
_2,_3,_9;
begin
{   DATA  FORTRAN  }
C[0] := 0.9857516;
C[1] := -1.357512E-2;
C[2] := 6.097578E-4;
C[3] := -5.479475E-5;
C[4] := 7.225671E-6;
C[5] := -1.222786E-6;
C[6] := 2.472061E-7;
C[7] := -5.717648E-8;
C[8] := 1.470625E-8;
C[9] := -4.124183E-9;
C[10] := 1.243043E-9;
C[11] := -3.98333E-10;
C[12] := 1.34579E-10;
C[13] := -4.7620E-11;
C[14] := 1.75553E-11;
C[15] := -6.710E-12;
C[16] := 2.651E-12;
C[17] := -1.079E-12;
C[18] := 4.51E-13;
C[19] := -1.93E-13;
C[20] := 8.5E-14;
C[21] := -4.0E-14;
C[22] := 1.7E-14;
C[23] := -8.0E-15;
C[24] := 4.0E-15;
C[25] := -2.0E-15;
C[26] := 1.0E-15;

IER := 0;
if ( X <= 0.0 )
 then goto _3;
if ( X <= 1.0 )
 then goto _2;
{      CYA X.GT.1 }
Y := 1.0/X;
ZP49R (Y,C,N,SX);
SX := SX/(12.0*X);
ALNGX := (X-0.5)*Ln(X)-X+SYS027+SX;
goto _9;
_2:
{      CYA 0.LE.X.LE.1 }
{      ALOG((X))=ALOG((X+1))-ALOG(X) }
Y := X+1.0;
Z := 1.0/Y;
ZP49R (Z,C,N,SX);
SX := SX/(12.0*Y);
ALNGX := (Y-0.5)*Ln(Y)-Y+SYS027+SX-Ln(X);
goto _9;
_3:
{      OTPATEH APYMEHT }
ALNGX := 1.0;
{      COOEHE O OKE }
IER := 67;
UTSF16(IER,11);
_9:
end;

end.
