Unit SFG1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF66R_p;

function SFG1R(N :Integer): Real;

implementation

function SFG1R(N :Integer): Real;
var
JN,J,IERR :Integer;
RAB :Real;
A :Array [0..32] of Real;
const
NMAX :Integer = 0;
label
_10,_20,_30,_40;
begin
{ Result -    SFG1R  FORTRANe }
{   DATA  FORTRAN  }
A[0] := 1.0;
if ( N > NMAX ) 
 then goto _10;
Result := A[N+0];
goto _40;
_10:
if ( N > 32 ) 
 then goto _30;
JN := NMAX+1;
for J:=JN to N do
 begin
  A[J+0] := J*A[J-1];
_20:
 end;
NMAX := N;
Result := A[N+0];
goto _40;
_30:
SF66R(N+1.0,RAB,IERR);
Result := Exp(RAB);
_40:
exit;
end;

end.
